## cothreads 0.10

=== Makefile ===
include ./Makefile.template

all:
	$(MAKE) -C $(SOURCEDIR) $@

install:
	$(MAKE) -C $(SOURCEDIR) $@

uninstall:
	$(MAKE) -C $(SOURCEDIR) $@

doc:
	$(MAKE) -C $(DOCDIR) $@

clean: ocamlclean
	$(MAKE) -C $(SOURCEDIR) $@
	$(MAKE) -C $(DOCDIR) $@
	$(MAKE) -C $(EXAMPLEDIR) $@

=== doc/Makefile ===
TOPDIR = ..
include $(TOPDIR)/Makefile.template

all: doc

doc:
	$(MKDIR) html
	$(MKDIR) man
	$(OCAMLDOC) -html -d html -colorize-code $(TOPDIR)/$(SOURCEDIR)/*.mli $(TOPDIR)/$(SOURCEDIR)/process/thread.mli
	$(OCAMLDOC) -man -d man -man-mini $(TOPDIR)/$(SOURCEDIR)/*.mli $(TOPDIR)/$(SOURCEDIR)/process/thread.mli

clean: 
	$(RM) html man *~ .depend

=== example/Makefile ===
include ../Makefile.template

IFRAY = $(if $(findstring ray,$@), $(if $(findstring opt,$@),ray.cmx,ray.cmo))
VMPARAM = -I +vmthreads $(IFRAY) cothreads.cma 
NATHPARAM = -I +threads $(IFRAY) unix.cma cothreads.cma
NATHOPTPARAM = $(NATHPARAM:%.cma=%.cmxa)
PROCPARAM = -I +process $(IFRAY) unix.cma cothreads.cma
PROCOPTPARAM = $(PROCPARAM:%.cma=%.cmxa)

%.vmth: %.cmo
	$(OCAMLC) -o $@ $(VMPARAM) $< 

%.nath: %.cmo
	$(OCAMLC) -o $@ $(NATHPARAM) $<

%.nath.opt: %.cmx
	$(OCAMLOPT) -o $@ $(NATHOPTPARAM) $<

%.proc: %.cmo
	$(OCAMLC) -o $@ $(PROCPARAM)  $<

%.proc.opt: %.cmx
	$(OCAMLOPT) -o $@ $(PROCOPTPARAM)  $<

ALLTEST = coth evt lock ray_col ray_nocol test mvar merge mcast phil santa

all: $(ALLTEST:%=%.vmth) $(ALLTEST:%=%.nath) $(ALLTEST:%=%.nath.opt) $(ALLTEST:%=%.proc) $(ALLTEST:%=%.proc.opt) 

clean: ocamlclean
	$(RM) *.vmth *.nath *.proc *.netw *.opt *.pgm


# TODO:
# NETWPARAM = -I +networker $(IFRAY) unix.cma cothreads.cma
# NETWOPTPARAM = $(NETWOPTPARAM:%.cma=%.cmxa)
# %.netw: %.cmo
# 	$(OCAMLC) -o $@ $(NETWPARAM) $<
# %.netw.opt: %.cmx
# 	$(OCAMLOPT) -o $@ $(NETWOPTPARAM) $<

=== src/Makefile ===
include ../Makefile.template

BACKENDS = threads vmthreads process

AUXMOD = libext libextunix
AUXMODBYT = $(AUXMOD:%=%.cmo)
AUXMODNAT = $(AUXMOD:%=%.cmx)

COMMONMOD = mutex condition event
COMMONMODINTFSRC = $(COMMONMOD:%=%.mli)
COMMONMODINTFCOM = $(COMMONMOD:%=%.cmi)

EXTRAMOD = cothread stm
EXTRAMODINTFSRC = $(EXTRAMOD:%=%.mli)
EXTRAMODINTFCOM = $(EXTRAMOD:%=%.cmi)

INSTALLFILES = $(COMMONMODINTFCOM) $(EXTRAMODINTFSRC) $(EXTRAMODINTFCOM) 


$(COMMONMODINTFSRC): %: $(OCAMLSTDLIBPATH)/%
	@if [ ! -L $@ ]; then ln -s $< .; fi

.PHONY: all install clean uninstall sub%

all: $(AUXMODBYT) $(AUXMODNAT) $(COMMONMODINTFCOM) $(EXTRAMODINTFCOM) suball

install: all subinstall
	$(MKDIR) $(INSTALLLIBDIR)
	$(CP) $(INSTALLFILES) $(INSTALLLIBDIR)

uninstall: subuninstall
	for i in $(INSTALLFILES); do $(RM) $(INSTALLLIBDIR)/$$i; done

clean: ocamlclean subclean
	find . -type l -exec $(RM) '{}' \;

sub%:
	@for i in $(BACKENDS); do $(MAKE) -C $$i $*; done

=== src/process/Makefile ===
include ../../Makefile.template

INCLUDES = -I ..

BACKEND = process

AUXMOD = libext libextunix
AUXMODBYT = $(AUXMOD:%=%.cmo)
AUXMODNAT = $(AUXMOD:%=%.cmx)
LOCALMOD = coordinator
COMMONMOD = mutex condition event cothread stm
COMMONMODNAT = $(COMMONMOD:%=%.cmx)
COMMONMODINTFSRC = $(COMMONMOD:%=%.mli)
COMMONMODINTFCOM = $(COMMONMOD:%=%.cmi)
COMMONMODINTF = $(COMMONMODINTFSRC) $(COMMONMODINTFCOM)
EXTRAMOD = thread
EXTRAMODNAT =$(EXTRAMOD:%=%.cmx)
EXTRAMODINTFCOM = $(EXTRAMOD:%=%.cmi)
ALLMOD = $(LOCALMOD) $(COMMONMOD) $(EXTRAMOD)
ALLMODBYT = $(ALLMOD:%=%.cmo)
ALLMODNAT = $(ALLMOD:%=%.cmx)

LIB = threads cothreads
LIBBYT = $(LIB:%=%.cma)
LIBNAT = $(LIB:%=%.cmxa)
LIBNATA = $(LIB:%=%.a)

INSTALLDIR = $(INSTALLLIBDIR)/$(BACKEND)
INSTALLFILES = $(COMMONMODINTFCOM) $(EXTRAMODINTFCOM) $(COMMONMODNAT) $(EXTRAMODNAT) $(LIBBYT) $(LIBNAT) $(LIBNATA)

$(LIBBYT): %: $(ALLMODBYT)
	$(OCAMLC) -a -o $@ $(AUXMODBYT) $(ALLMODBYT)
$(LIBNAT): %: $(ALLMODNAT)
	$(OCAMLOPT) -a -o $@ $(AUXMODNAT) $(ALLMODNAT)

$(COMMONMODINTF): %: ../%
	@if [ ! -e $@ -a -e $< ]; then ln -s $< .; fi

.PHONY: all install clean uninstall

all: $(COMMONMODINTF) $(LIBBYT) $(LIBNAT)

install: all
	$(MKDIR) $(INSTALLDIR)
	$(CP) $(INSTALLFILES) $(INSTALLDIR)

clean: ocamlclean

uninstall:
	$(RM) $(INSTALLDIR)

=== src/threads/Makefile ===
include ../../Makefile.template

INCLUDES= -I +threads -I ..

BACKEND = threads

AUXMOD = libext
AUXMODBYT = $(AUXMOD:%=%.cmo)
AUXMODNAT = $(AUXMOD:%=%.cmx)

COMMONMOD = thread mutex condition event
COMMONMODNAT =  $(COMMONMOD:%=%.cmx)
COMMONMODNATA = $(COMMONMOD:%=%.o)

EXTRAMOD = cothread stm
EXTRAMODBYT = $(EXTRAMOD:%=%.cmo)
EXTRAMODNAT = $(EXTRAMOD:%=%.cmx)
EXTRAMODINTFSRC = $(EXTRAMOD:%=%.mli)
EXTRAMODINTFCOM = $(EXTRAMOD:%=%.cmi)
EXTRAMODINTF = $(EXTRAMODINTFSRC) $(EXTRAMODINTFCOM)

LIB = cothreads
LIBBYT = $(LIB:%=%.cma)
LIBNAT = $(LIB:%=%.cmxa)
LIBNATA = $(LIB:%=%.a)

INSTALLDIR = $(INSTALLLIBDIR)/$(BACKEND)
INSTALLFILES = $(EXTRAMODINTFCOM) $(EXTRAMODNAT) $(LIBBYT) $(LIBNAT) $(LIBNATA)

$(EXTRAMODINTF):%:../%
	@if [ ! -e $@ -a -e $< ]; then ln -s $< .; fi

$(COMMONMODNAT): %: $(OCAMLSTDLIBPATH)/threads/%
	@if [ ! -e $@ -a -e $< ]; then ln -s $< .; fi

$(COMMONMODNATA):$(OCAMLSTDLIBPATH)/threads/threads.a
	$(AR) -x $<

$(LIBBYT): $(EXTRAMODBYT)
	$(OCAMLC) -a -o $@ threads.cma $(AUXMODBYT) $+
$(LIBNAT): $(COMMONMODNAT) $(COMMONMODNATA) $(EXTRAMODNAT) 
	$(OCAMLOPT) -a -o $@ $(COMMONMODNAT) $(AUXMODNAT) $(EXTRAMODNAT) -cclib -lthreadsnat -cclib -lunix -cclib -lpthread

.PHONY: all install clean uninstall

all: $(EXTRAMODINTF) $(LIBBYT) $(LIBNAT)

install: all
	$(MKDIR) $(INSTALLDIR)
	$(CP) $(INSTALLFILES) $(INSTALLDIR)

clean: ocamlclean

uninstall:
	for i in $(INSTALLFILES); do $(RM) $(INSTALLDIR)/$$i; done

=== src/vmthreads/Makefile ===
include ../../Makefile.template

INCLUDES=-I +vmthreads -I ..

BACKEND = vmthreads

AUXMOD = libext
AUXMODBYT = $(AUXMOD:%=%.cmo)

COMMONMOD = cothread stm
COMMONMODSRC = $(COMMONMOD:%=%.ml)
COMMONMODBYT = $(COMMONMOD:%=%.cmo)
COMMONMODINTFSRC = $(COMMONMOD:%=%.mli)
COMMONMODINTFCOM = $(COMMONMOD:%=%.cmi)
COMMONMODINTF = $(COMMONMODINTFSRC) $(COMMONMODINTFCOM)

LIB = cothreads
LIBBYT = $(LIB:%=%.cma)

INSTALLDIR = $(INSTALLLIBDIR)/$(BACKEND)
INSTALLFILES = $(COMMONMODINTFCOM) $(LIBBYT)


$(LIBBYT): $(COMMONMODBYT)
	$(OCAMLC) -a -o $@ threads.cma $(AUXMODBYT) $+

$(COMMONMODINTF):%:../%
	@if [ ! -e $@ -a -e ../$@ ]; then ln -s $< .; fi

$(COMMONMODSRC):%:../threads/%
	@if [ ! -e $@ -a -e $< ]; then ln -s $< .; fi

.PHONY: all install clean uninstall

all: $(COMMONMODSRC) $(COMMONMODINTF) $(LIBBYT)

install: all
	$(MKDIR) $(INSTALLDIR)
	$(CP) $(INSTALLFILES) $(INSTALLDIR)

clean: ocamlclean

uninstall:
	for i in $(INSTALLFILES); do $(RM) $(INSTALLDIR)/$$i; done

=== debian/changelog ===
cothreads (0.10-6build2) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Nov 2023 08:12:47 +0100

cothreads (0.10-6build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:19:39 +0100

cothreads (0.10-6) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Switch to dh, bump debhelper compat level to 13
  * Do not try to build vmthreads backend
  * Add Semaphore to --nodefined-map
  * Install in a subdir of OCaml stdlib dir
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.6.0
  * Bump debian/watch version to 4

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Set upstream metadata fields: Archive, Name, Repository.

 -- Stéphane Glondu <glondu@debian.org>  Sun, 02 Jan 2022 08:54:32 +0100

cothreads (0.10-5) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 17 Sep 2019 09:47:14 +0200

cothreads (0.10-4) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * Switch source package format to 3.0 (quilt)
  * Bump debhelper compat to 10
  * Update Vcs-*

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders (Closes: #869317)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2017 06:24:50 +0200

cothreads (0.10-3) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Use dh_ocaml (and related tools) to build the package and compute
    the dependencies.
  * Move the package to section ocaml.

  [ Mehdi Dogguy ]
  * Cosmetic changes in debian/control
  * Update email address
  * Bump standards to 3.8.3, no changes needed
  * Build-depend on OCaml 3.11.1-3~
  * Bump dh-ocaml version to 0.9.1
  * Switch order of inclusion for debhelper.mk and dpatch.mk to
    workaround a bug of cdbs.
  * Add a nodefined-map for dh-ocaml to not export some modules
    (Closes: #549784).

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 31 Oct 2009 13:36:33 +0100

cothreads (0.10-2) unstable; urgency=low

  * Add build-depends on dh-ocaml
  * Upgrade Standards-Version to 3.8.0 (README.source)
  * Switch packaging to git
  * Remove verbatim text in debian/control
  * Update homepage field
  * Use rules/ocaml.mk, add versionned dependency on dh-ocaml
  * Update debian/copyright file to use
    http://wiki.debian.org/Proposals/CopyrightFormat

 -- Sylvain Le Gall <gildor@debian.org>  Fri, 06 Mar 2009 22:56:54 +0100

cothreads (0.10-1) unstable; urgency=low

  [ Erik de Castro Lopo ]
  * Initial upload (Closes: #444082)

  [ Sylvain Le Gall ]
  * Use ocaml 3.10.0-9 for generating .ocamldoc-apiref automatically

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir

  [ Mehdi Dogguy ]
  * enhance META
  * add myself as an Uploader
  * set Maintainer to d-o-m, and Erik as uploader
  * bump standards-version
  * remove line '@OCamlStdlibDir@/cothreads' from libcothreads-ocaml-dev.dirs.in
    (thanks lintian)

 -- Sylvain Le Gall <gildor@debian.org>  Sat, 10 May 2008 00:47:16 +0200

=== debian/control ===
Source: cothreads
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>,
 Erik de Castro Lopo <erikd@mega-nerd.com>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 dh-ocaml
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: http://sourceforge.net/projects/cothreads/
Vcs-Git: https://salsa.debian.org/ocaml-team/cothreads.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/cothreads

Package: libcothreads-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: concurrent programming library for OCaml
 This library enhances the Threads library of the standard OCaml distribution
 in two dimensions:
 .
 - It implements the same API of the standard Threads library on different
 execution engines (process, networker), so that a single copy of
 source code can be compiled and deployed to different environments
 without modification.
 - It is also a super set of the standard Threads library, with extra
 components (STM etc.), functions (spawn etc.) and features (object-level
 compatibility etc.).
 .
 This package provides static libraries, interfaces, and documentation
 for coThreads.

=== debian/watch ===
version=4
http://sf.net/cothreads/cothreads_([0-9].*)\.tar\.bz2
